#include <iostream>
#include <vector>

using namespace std;

void greeting();
double order(vector<const char*> persons, double available_money);
void billing(double change, double available_money);
double get_price(int index);

/**
 * \brief ice cream sale
 * \return zero if successful.
 */
int main()
{
	const auto persons = {"Freund 1", "Freund 2", "Du"};
	const auto available_money = 5.0;

	greeting();
	const auto change = order(persons, available_money);
	billing(change, available_money);
	return 0;
}

/**
 * \brief Writes a greeting message.
 */
void greeting()
{
	cout << "Hallo!" << endl;
	cout << "Folgende Eissorten sind vorhanden:" << endl;
	cout << "1. Capri: 1,10 Euro" << endl;
	cout << "2. Nogger: 1,60 Euro" << endl;
	cout << "3. Cornetto : 2,30 Euro" << endl;
	cout << endl;
}

/**
 * \brief Take an order and pay attention to the available money.
 * \param persons The people at the counter 
 * \param available_money Available money
 * \return Remaining money.
 */
double order(vector<const char*> persons, double available_money)
{
	for (auto person : persons)
	{
		cout << "Hallo " << person << "!" << endl;
		if (available_money < 1.1)
		{
			cout << "Sie koennen kein Eis mehr kaufen." << endl;
			break;
		}
		cout << "Bitte geben Sie ihre Bestellung auf (1-3): ";
		int input;
		cin >> input;
		available_money -= get_price(input);
	}
	return available_money;
}

/**
 * \brief Creates the bill and returns the change
 * \param change The remaining money
 * \param available_money The payed money.
 */
void billing(const double change, const double available_money)
{
	cout << endl;
	cout << "Zu zahlender Betrag: " << available_money - change << " Euro" << endl;
	cout << "Ihr Restgeld betraegt: " << change << " Euro" << endl;
	cout << endl;
	cout << "Danke, beehren sie uns bald wieder!";
}

/**
 * \brief get prices of chosen product.
 * \param index of the product.
 * \return the price of the product.
 */
double get_price(const int index)
{
	switch (index)
	{
	case 1:
		return 1.1;
	case 2:
		return 1.6;
	case 3:
		return 2.3;
	default:
		return 0.0;
	}
}
